/*  RAGE2X for GP2X

    Copyright (C) 2006  JyCet

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// RAGE2X
// GNGEO2X Frontend
// JYCET 2K6 2K7
// v1.0.1 b10

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>

#include <fcntl.h>
#include <sys/mman.h>

#include <SDL/SDL.h>

#include "rage2x.h"
#include "frame_skip.h"
#ifdef WIZ
#include "pollux_set.h"
#else
#include "cpuclock.h"
#endif

#include "./GFX/spr_BG.h"
#include "./GFX/spr_FONT7.h"
#include "./GFX/spr_SELECTEUR.h"
#include "./GFX/spr_NOPRW.h"
#include "./GFX/spr_TITRE.h"
#include "./GFX/spr_OPTIONS.h"

#include "rage2x_ecriture.h"
#include "rage2x_lecture.h"
#include "rage2x_credit.h"
#include "rage2x_edit.h"

#ifdef WIZ
#ifndef WIZ_MMUHACKOFF 
#define WIZ_MMUHACKOFF 0x00040000
#endif
#ifndef WIZ_RAMTWEAKOFF
#define WIZ_RAMTWEAKOFF 0x00080000
#endif
#ifndef WIZ_TEARING
#define WIZ_TEARING 0x00400000
#endif
#endif

void libere_memoire()
{
	int ii,iii;
	
	printf("liberation des surfaces\n");
	SDL_FreeSurface(ecran);
	SDL_FreeSurface(ecran2);
	SDL_FreeSurface(bg);
	SDL_FreeSurface(font);
	SDL_FreeSurface(preview0);
	SDL_FreeSurface(preview);
	SDL_FreeSurface(selecteur);
	SDL_FreeSurface(titre);
	SDL_FreeSurface(indicateur);
	printf("liberation des allocations memoires DAT\n");
	for ( ii=0 ; ii<nb_list[0] ; ++ii ){
		free(data.name[ii]);
		free(data.zip[ii]);
		free(data.manufacturer[ii]);
		free(data.type[ii]);
		free(data.status[ii]);
	}
	printf("liberation des allocations memoires LNG\n");
	for ( ii=0 ; ii<lng_num ; ++ii )
		for ( iii=0 ; iii<30 ; ++iii ){
			free(txt[iii][ii]);
		}
	printf("liberation des allocations memoires CMD\n");
	if (rage2x_cmd.nb){
		for ( ii=0 ; ii<rage2x_cmd.nb ; ++ii ){
			free(rage2x_cmd.ligne[ii]);
		}
	}else printf("Aucune commande externe dans rage2x.cmd\n");
		
	printf("FIN liberation RAM\n");
}

void put_string(char *string, unsigned int pos_x, unsigned int pos_y, unsigned char couleur)
{
	unsigned char temp,i;
	temp=strlen(string);
	for(i=0;i<temp;++i)
	{
		if (font7x[*string]) drawSprite(font, ecran, font7x[*string], couleur, pos_x, pos_y, 7, 8);
		pos_x+=6;
		++string;
	}
}

void put_string25(char *string, unsigned int pos_x, unsigned int pos_y, unsigned char couleur)
{
	unsigned char temp,i;
	temp=strlen(string);
	if (temp>25) temp=25;
	for(i=0;i<temp;++i)
	{
		if (font7x[*string]) drawSprite(font, ecran, font7x[*string], couleur, pos_x, pos_y, 7, 8);
		pos_x+=6;
		++string;
	}
}

void rafraichir_ecran(void)
{
#ifndef WIZ
	if (flag_TV){
		drawSprite(ecran, ecran2, 0, 0, options.tvoffset_x, options.tvoffset_y, 320, 240);
		SDL_UpdateRect( ecran2 , options.tvoffset_x, options.tvoffset_y, 320, 240 );
		frame_skip(0);
	}else SDL_Flip(ecran);
#else
	SDL_BlitSurface(ecran, NULL, ecran2, NULL);
#endif
}

void init_titre()
{
	rw = SDL_RWFromMem(spr_BG,sizeof(spr_BG)/sizeof(unsigned char));
	Tmp = SDL_LoadBMP_RW(rw,0);
	bg = SDL_DisplayFormat(Tmp);
	SDL_FreeSurface(Tmp);
	//SDL_SetColorKey(bg,SDL_SRCCOLORKEY,SDL_MapRGB(bg->format,255,0,255));
	
	//bg = SDL_LoadBMP_RW(rw,0);
	rw = SDL_RWFromMem(spr_FONT7,sizeof(spr_FONT7)/sizeof(unsigned char));
	Tmp = SDL_LoadBMP_RW(rw,0);
	font = SDL_DisplayFormat(Tmp);
	SDL_FreeSurface(Tmp);
	SDL_SetColorKey(font,SDL_SRCCOLORKEY,SDL_MapRGB(font->format,255,0,255));
	
//	font = SDL_LoadBMP_RW(rw,0);
	rw = SDL_RWFromMem(spr_SELECTEUR,sizeof(spr_SELECTEUR)/sizeof(unsigned char));
	Tmp = SDL_LoadBMP_RW(rw,0);
	selecteur = SDL_DisplayFormat(Tmp);
	SDL_FreeSurface(Tmp);
	//SDL_SetColorKey(selecteur,SDL_SRCCOLORKEY,SDL_MapRGB(selecteur->format,255,0,255));
	
//	selecteur = SDL_LoadBMP_RW(rw,0);
	rw = SDL_RWFromMem(spr_TITRE,sizeof(spr_TITRE)/sizeof(unsigned char));
	Tmp = SDL_LoadBMP_RW(rw,0);
	titre = SDL_DisplayFormat(Tmp);
	SDL_FreeSurface(Tmp);
	SDL_SetColorKey(titre,SDL_SRCCOLORKEY,SDL_MapRGB(titre->format,255,0,255));
	
//	titre = SDL_LoadBMP_RW(rw,0);
	rw = SDL_RWFromMem(spr_OPTIONS,sizeof(spr_OPTIONS)/sizeof(unsigned char));
	Tmp = SDL_LoadBMP_RW(rw,0);
	indicateur = SDL_DisplayFormat(Tmp);
	SDL_FreeSurface(Tmp);
	SDL_SetColorKey(indicateur,SDL_SRCCOLORKEY,SDL_MapRGB(indicateur->format,255,0,255));
	
//	indicateur = SDL_LoadBMP_RW(rw,0);
	
	rw = SDL_RWFromMem(spr_NOPRW,sizeof(spr_NOPRW)/sizeof(unsigned char));
	Tmp = SDL_LoadBMP_RW(rw,0);
	preview = SDL_DisplayFormat(Tmp);
	preview0 = SDL_DisplayFormat(Tmp);
	SDL_FreeSurface(Tmp);
}

void commun_gfx (void)
{
	//bg scrolling
	for (y=-scroll_bg;y<320;y+=64)
		for (x=-scroll_bg;x<320;x+=64){
			drawSprite(bg, ecran, 0, 0, x, y, 64, 64);
		}
		
	if (options.scrollbg){
		++demi_scroll;
		demi_scroll&=1;
		scroll_bg+=demi_scroll;
		scroll_bg&=63;
	}

	//titre
	drawSprite(titre, ecran, 0,0, 9, 1, 145, 28);
	//fenetre_x_tmp=fenetre_x1+2;

	//(prw)
	ligneH(ecran,165,2,152, Pblanc);
	ligneH(ecran,165,115,152, Pblanc);
	ligneV(ecran,164,3,112, Pblanc);
	ligneV(ecran,317,3,112, Pblanc);
	drawSprite(preview, ecran, 0, 0, 165, 3, 152, 112);
			
	//affiche nom complet
	sprintf((char*)g_string, "%s",data.name[list[choix_jeu.num][options.listing]]);
	put_string(g_string,4,230,BLANC);
}

void affiche_ligne_options(unsigned char num, unsigned char coor_y)
{
	switch (num)
	{
		case OPTION_NUM_GNGEO2X_SHOWFPS:
			if (options.fps) drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7); 
			else drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7); 
			put_string25( txt[TXT_SHOW_FRAMERATE][options.langue] ,fenetre_x1+10,coor_y,BLANC);
		break;
		case OPTION_NUM_GNGEO2X_SOUND:
			if (options.sound==1) drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7);
			else drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7);
			put_string25( txt[TXT_ACTIVATE_SOUND][options.langue] ,fenetre_x1+10,coor_y,BLANC);
		break;
		case OPTION_NUM_GNGEO2X_SAMPLERATE:
			put_string25("11kHz",fenetre_x1+10,coor_y,BLANC);
			put_string25("22kHz",fenetre_x1+64,coor_y,BLANC);
			put_string25("44kHz",fenetre_x1+118,coor_y,BLANC);
			if (options.rate==0){
				drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7);
				drawSprite(indicateur, ecran, 0,7, fenetre_x1+54, coor_y, 7, 7);
				drawSprite(indicateur, ecran, 0,7, fenetre_x1+108, coor_y, 7, 7);
			}else if (options.rate==1){
				drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7);
				drawSprite(indicateur, ecran, 0,0, fenetre_x1+54, coor_y, 7, 7);
				drawSprite(indicateur, ecran, 0,7, fenetre_x1+108, coor_y, 7, 7);
			}else{
				drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7);
				drawSprite(indicateur, ecran, 0,7, fenetre_x1+54, coor_y, 7, 7);
				drawSprite(indicateur, ecran, 0,0, fenetre_x1+108, coor_y, 7, 7);
			}
		break;
		case OPTION_NUM_GNGEO2X_CPU:
			sprintf((char*)g_string, "%s %dMHz",txt[TXT_CPU_SPEED][options.langue],options.cpu);
			put_string25(g_string,fenetre_x1,coor_y,BLANC);
		break;
		case OPTION_NUM_GNGEO2X_68K:
			sprintf((char*)g_string, "%s %d%c",txt[TXT_68K_CLOCK][options.langue],options.cpu68k,37);
			put_string25(g_string,fenetre_x1,coor_y,BLANC);
		break;
		case OPTION_NUM_GNGEO2X_Z80:
			sprintf((char*)g_string, "%s %d%c",txt[TXT_Z80_CLOCK][options.langue],options.cpuz80,37);
			put_string25(g_string,fenetre_x1,coor_y,BLANC);
		break;
		case OPTION_NUM_GNGEO2X_RASTER:
			if (options.raster) drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7);
			else drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7);
			put_string25(txt[TXT_ACTIVATE_RASTER][options.langue],fenetre_x1+10,coor_y,BLANC);
		break;
		case OPTION_NUM_GNGEO2X_WIDE:
			if (options.largeur) drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7);
			else drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7);
			put_string25(txt[TXT_RESOLUTION_320x224][options.langue],fenetre_x1+10,coor_y,BLANC);
		break;
		case OPTION_NUM_GNGEO2X_SYSTEM:
			if (options.system==0) put_string25(txt[TXT_SYSTEM_CONSOLE][options.langue],fenetre_x1,coor_y,BLANC);
			else if (options.system==1) put_string25(txt[TXT_SYSTEM_ARCADE][options.langue],fenetre_x1,coor_y,BLANC);
			else put_string25(txt[TXT_SYSTEM_UNIBIOS][options.langue],fenetre_x1,coor_y,BLANC);
		break;
		case OPTION_NUM_GNGEO2X_COUNTRY:
			if (options.pays==0) put_string25(txt[TXT_COUNTRY_JAPAN][options.langue],fenetre_x1,coor_y,BLANC);
			else if (options.pays==1) put_string25(txt[TXT_COUNTRY_USA][options.langue],fenetre_x1,coor_y,BLANC);
			else put_string25(txt[TXT_COUNTRY_EUROPE][options.langue],fenetre_x1,coor_y,BLANC);
		break;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////			
		case OPTION_NUM_GNGEO2X_TWEAK:
			if (options.tweak) drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7); 
			else drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7); 
			put_string25( txt[TXT_CRAIGX_RAM_TIMING][options.langue] ,fenetre_x1+10,coor_y,BLANC);
		break;
		case OPTION_NUM_GNGEO2X_VSYNC:
			if (options.vsync) drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7); 
			else drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7); 
			put_string25( txt[TXT_VSYNC][options.langue] ,fenetre_x1+10,coor_y,BLANC);
		break;
#ifdef WIZ
		case OPTION_NUM_GNGEO2X_DOUBLEBUF:
			if (options.doublebuf) drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7); 
			else drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7); 
			put_string25( txt[TXT_DOUBLEBUFFERING][options.langue] ,fenetre_x1+10,coor_y,BLANC);
		break;
		case OPTION_NUM_GNGEO2X_TEARINGFIX:
			if (options.tearingfix) drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7); 
			else drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7); 
			put_string25( txt[TXT_TEARINGFIX][options.langue] ,fenetre_x1+10,coor_y,BLANC);
		break;
#else
		case OPTION_NUM_GNGEO2X_TVOUT:
			if (options.tvout) drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7); 
			else drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7); 
			put_string25( txt[TXT_TVOUT][options.langue] ,fenetre_x1+10,coor_y,BLANC);
		break;
		case OPTION_NUM_GNGEO2X_TVX:
			sprintf((char*)g_string, "%s %dpx", txt[TXT_TV_SCREEN_OFFSET_X][options.langue] ,options.tvoffset_x);
			put_string25(g_string,fenetre_x1,coor_y,BLANC);
		break;
#endif
		case OPTION_NUM_GNGEO2X_TVY:
#ifndef WIZ
			sprintf((char*)g_string, "%s %dpx", txt[TXT_TV_SCREEN_OFFSET_Y][options.langue] ,options.tvoffset_y);
			put_string25(g_string,fenetre_x1,coor_y,BLANC);
#endif
		break;
		case OPTION_NUM_GNGEO2X_DUMPSPR:
			if (options.dumpsprite) drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7); 
			else drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7); 
			put_string25( txt[TXT_DUMP_SPRITE][options.langue] ,fenetre_x1+10,coor_y,BLANC);
		break;
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		case OPTION_NUM_RAGE2X_REPEATSPEED:
			sprintf((char*)g_string, "%s %d",txt[TXT_GUI_SPEED][options.langue],options.guispeed);
			put_string25(g_string,fenetre_x1,coor_y,BLANC);
		break;
		case OPTION_NUM_GNGEO2X_FRONTEND:
			if (options.reload) drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7);
			else drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7);
			put_string25(txt[TXT_AUTO_RELOAD_GUI][options.langue],fenetre_x1+10,coor_y,BLANC);
		break;
		case OPTION_NUM_RAGE2X_LANGAGE:
			put_string25(txt[TXT_ENGLISH_LANGUAGE][options.langue],fenetre_x1,coor_y,BLANC);
		break;
		case OPTION_NUM_RAGE2X_LIST:
			if (options.listing==0) put_string25(txt[TXT_SEE_COMPLETE_LIST][options.langue],fenetre_x1,coor_y,BLANC);
			else if (options.listing==1) put_string25(txt[TXT_SEE_LIST_AVAILABLE][options.langue],fenetre_x1,coor_y,BLANC);
			else put_string25(txt[TXT_SEE_MISSING_LIST][options.langue],fenetre_x1,coor_y,BLANC);
		break;
		case OPTION_NUM_RAGE2X_RUN:
			if (options.inv_run) drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7);
			else drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7);
			put_string(txt[TXT_INVERT_RUN_CHOICE][options.langue],fenetre_x1+10,coor_y,BLANC);
		break;
		case OPTION_NUM_RAGE2X_CLOCK:
			sprintf((char*)g_string, "%s %dMHz", txt[TXT_RAGE2X_CLOCK][options.langue] , options.rage2xclock);
			put_string25(g_string,fenetre_x1,coor_y,BLANC);
		break;
		case OPTION_NUM_RAGE2X_SCROLLBG:
			if (options.scrollbg) drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7);
			else drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7);
			put_string25( txt[TXT_WALLPAPER_SCROLLING][options.langue] ,fenetre_x1+10,coor_y,BLANC);
		break;
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		case OPTION_NUM_RAGE2X_EDIT_PATH1:
			put_string25( txt[TXT_EDIT_ROMS_PATH_1][options.langue] ,fenetre_x1 ,coor_y ,BLANC);
		break;
		case OPTION_NUM_RAGE2X_EDIT_PATH2:
			put_string25( txt[TXT_EDIT_ROMS_PATH_2][options.langue] ,fenetre_x1 ,coor_y ,BLANC);
		break;
		case OPTION_NUM_RAGE2X_EDIT_EXIT:
			put_string25( txt[TXT_EDIT_EXIT_PROGRAM][options.langue] ,fenetre_x1 ,coor_y ,BLANC);
		break;
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		case OPTION_NUM_SAVE:
			put_string(txt[TXT_SAVE_ALL_SETTING][options.langue],fenetre_x1,coor_y,options.need_save);
		break;
		case OPTION_NUM_SAVE_CF:
			sprintf((char*)g_string, "%s %s.cf",txt[TXT_GENERATE][options.langue],data.zip[list[choix_jeu.num][options.listing]]);
			put_string25(g_string,fenetre_x1,coor_y,options.need_save_cf);
		break;
		case OPTION_NUM_RETURN:
			put_string25( txt[TXT_RETURN_TO_GAME_LIST][options.langue] , fenetre_x1 , coor_y , BLANC );
		break;
		default:
			if (rage2x_cmd.etat[ num - NOMBRE_OPTIONS - 1 ]) drawSprite(indicateur, ecran, 0,0, fenetre_x1, coor_y, 7, 7);
			else drawSprite(indicateur, ecran, 0,7, fenetre_x1, coor_y, 7, 7);
			put_string25( rage2x_cmd.ligne[ num - NOMBRE_OPTIONS - 1 ] ,fenetre_x1+10,coor_y, BLEU );
		break;
	}
}

void sp_options(void)
{
	#define OPTIONS_POSY	37
	#define OPTIONS_NB_LIGNE_AFF	18
	#define OPTIONS_MILIEU_LIGNE_AFF	9
	
	unsigned int compteur = 1;
	unsigned char option_start_y;
	unsigned char num;
	unsigned char limite_options = NOMBRE_OPTIONS + rage2x_cmd.nb ;
	options.offset_num = 0;
	options.num = 0;
	options.y = OPTIONS_POSY-1;
	
	int OExit = 0;
	while (!OExit)
	{
		commun_gfx();
		
		//options
		
		ligneH(ecran,fenetre_x1-1,34,157, Pblanc);
		ligneH(ecran,fenetre_x1-1,218,157, Pblanc);
		ligneV(ecran,fenetre_x1-2,35,183, Pblanc);
		ligneV(ecran,fenetre_x1+156,35,183, Pblanc);
		
		drawSprite(selecteur, ecran, 0, 0, fenetre_x1-1, options.y, 157, 10);
	
		option_start_y = OPTIONS_POSY ;
		for ( num = options.offset_num ; num < ( options.offset_num + OPTIONS_NB_LIGNE_AFF ) ; ++num){
			affiche_ligne_options( num , option_start_y );
			option_start_y += 10;
		}
			
			
		ligneH(ecran,fenetre_x2-3,121,152, Pblanc);
		ligneH(ecran,fenetre_x2-3,227,152, Pblanc);
		ligneV(ecran,fenetre_x2-4,122,105, Pblanc);
		ligneV(ecran,fenetre_x2+149,122,105, Pblanc);

		//info *.cf
		sprintf((char*)g_string, "%s.cf",data.zip[list[choix_jeu.num][options.listing]]);
		if (flag_cf_file) put_string25(g_string,fenetre_x2,124,VERT);
		else put_string25(g_string,fenetre_x2,124,ROUGE);
		
		sprintf((char*)g_string, "cpu_speed %sMHz",conf.cpu_speed);
		put_string25(g_string,fenetre_x2,136,BLANC);
		sprintf((char*)g_string, "68kclock %s%c",conf.clock68k,37);
		put_string25(g_string,fenetre_x2,145,BLANC);
		sprintf((char*)g_string, "z80clock %s%c",conf.z80clock,37);
		put_string25(g_string,fenetre_x2,154,BLANC);
		sprintf((char*)g_string, "sound %s",conf.sound);
		put_string25(g_string,fenetre_x2,163,BLANC);
		sprintf((char*)g_string, "samplerate %sHz",conf.samplerate);
		put_string25(g_string,fenetre_x2,172,BLANC);				
		sprintf((char*)g_string, "showfps %s",conf.showfps);
		put_string25(g_string,fenetre_x2,181,BLANC);
		sprintf((char*)g_string, "raster %s",conf.raster);
		put_string25(g_string,fenetre_x2,190,BLANC);				
		sprintf((char*)g_string, "system %s",conf.system);
		put_string25(g_string,fenetre_x2,199,BLANC);
		sprintf((char*)g_string, "country %s",conf.country);
		put_string25(g_string,fenetre_x2,208,BLANC);
		sprintf((char*)g_string, "screen320 %s",conf.screen320);
		put_string25(g_string,fenetre_x2,217,BLANC);
			
		rafraichir_ecran();
		
		SDL_PollEvent(&event);
		if (event.type==SDL_JOYBUTTONDOWN){
			if (compteur==0 || (compteur>30 && ((compteur&joy_speed[options.guispeed])==0))){
				if (event.jbutton.button==GP2X_BUTTON_UP){
					if ( options.num == 0 && compteur==0 ){
						options.y = OPTIONS_POSY - 1 + ( (OPTIONS_NB_LIGNE_AFF-1) *10) ;
						options.num = limite_options;
						options.offset_num = limite_options - (OPTIONS_NB_LIGNE_AFF-1);
					}else{
						if ( options.num > ( limite_options - OPTIONS_MILIEU_LIGNE_AFF ) || options.offset_num == 0 ){
							if (options.num>0){
								options.y -= 10;
								--options.num;
							}
						}else{
							--options.offset_num;
							--options.num;
						}
					}
				}else if (event.jbutton.button==GP2X_BUTTON_DOWN){
					if ( options.num == limite_options && compteur==0 ){
						options.y = OPTIONS_POSY-1;
						options.num = 0;
						options.offset_num = 0;
					}else{
						if (options.num < OPTIONS_MILIEU_LIGNE_AFF || options.offset_num == ( limite_options - (OPTIONS_NB_LIGNE_AFF-1) ) ){
							if ( options.num < limite_options ){
								++options.num;
								options.y+=10;
							}
						}else{
							++options.offset_num;
							++options.num;
						}
					}
				}else if (event.jbutton.button==GP2X_BUTTON_B || event.jbutton.button==GP2X_BUTTON_RIGHT){
					switch (options.num)
					{
						case OPTION_NUM_GNGEO2X_SHOWFPS:
							++options.fps;
							options.fps&=1;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_SOUND:
							++options.sound;
							options.sound&=1;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_SAMPLERATE:
							++options.rate;
							if (options.rate==3) options.rate=0;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_CPU:
							++options.cpu;
#ifdef WIZ
							if (options.cpu==911) options.cpu=100;
#else
							if (options.cpu==311) options.cpu=100;
#endif
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_68K:
							++options.cpu68k;
							if (options.cpu68k==51) options.cpu68k=-50;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_Z80:
							++options.cpuz80;
							if (options.cpuz80==51) options.cpuz80=-50;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_RASTER:
							++options.raster;
							options.raster&=1;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_WIDE:
							++options.largeur;
							options.largeur&=1;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_SYSTEM:
							++options.system;
							if (options.system==3) options.system=0;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_COUNTRY:
							++options.pays;
							if (options.pays==3) options.pays=0;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_TWEAK:
							++options.tweak;
							options.tweak &= 1;
							options.need_save=ROUGE;
						break;
						case OPTION_NUM_GNGEO2X_VSYNC:
							++options.vsync;
							options.vsync &= 1;
							options.need_save=ROUGE;
						break;
#ifdef WIZ
						case OPTION_NUM_GNGEO2X_DOUBLEBUF:
							++options.doublebuf;
							options.doublebuf &= 1;
							options.need_save=ROUGE;
						break;
						case OPTION_NUM_GNGEO2X_TEARINGFIX:
							++options.tearingfix;
							options.tearingfix &= 1;
							options.need_save=ROUGE;
						break;
#else
						case OPTION_NUM_GNGEO2X_TVOUT:
							++options.tvout;
							options.tvout &= 1;
							options.need_save=ROUGE;
						break;
						case OPTION_NUM_GNGEO2X_TVX:
							++options.tvoffset_x;
							if (options.tvoffset_x == 32) options.tvoffset_x = -32;
							if (flag_TV){
								carre_plein( ecran2 , 0 , 0 , 360 , 288 , Pnoir );
								SDL_UpdateRect( ecran2 , 0,0,0,0 );
							}
							options.need_save=ROUGE;
						break;
#endif
						case OPTION_NUM_GNGEO2X_TVY:
#ifndef WIZ
							++options.tvoffset_y;
							if (options.tvoffset_y == 32) options.tvoffset_y = -32;
							if (flag_TV){
								carre_plein( ecran2 , 0 , 0 , 360 , 288 , Pnoir );
								SDL_UpdateRect( ecran2 , 0,0,0,0 );
							}
							options.need_save=ROUGE;
#endif
						break;
						case OPTION_NUM_GNGEO2X_DUMPSPR:
							++options.dumpsprite;
							options.dumpsprite &= 1;
							options.need_save=ROUGE;
						break;
						case OPTION_NUM_RAGE2X_REPEATSPEED:
							++options.guispeed;
							if (options.guispeed==3) options.guispeed=0;
							options.need_save=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_FRONTEND:
							++options.reload;
							options.reload&=1;
							options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_LANGAGE:
							++options.langue;
							if (options.langue==lng_num) options.langue=0;
							options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_LIST:
							++options.listing;
							if (options.listing==3) options.listing=0;
							choix_jeu.y=36;
							choix_jeu.num=choix_jeu.offset_num=0;
							options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_RUN:
							++options.inv_run;
							options.inv_run&=1;
							options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_CLOCK:
							++options.rage2xclock;
#ifdef WIZ
							if ( options.rage2xclock == 534) options.rage2xclock = 66;
#else
							if ( options.rage2xclock == 134) options.rage2xclock = 66;
#endif
							options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_SCROLLBG:
							++options.scrollbg;
							options.scrollbg &= 1;
							options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_EDIT_PATH1:
							if ( edition_path(options.path[0] , 0 ) ) options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_EDIT_PATH2:
							if ( edition_path(options.path[1] , 1 ) ) options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_EDIT_EXIT:
							if ( edition_path(quit.temp , 2 ) ) options.need_save=ROUGE;
							break;
						case OPTION_NUM_SAVE:
							write_cfg();
							options.need_save=VERT;
							options.need_save_cf=VERT;
							break;
						case OPTION_NUM_SAVE_CF:
							write_cf(choix_jeu.num);
							load_cfg();
							options.need_save=VERT;
							options.need_save_cf=VERT;
							break;
						case OPTION_NUM_RETURN:
							if ( fenetre.ptr_mvt==0 ) fenetre.next=0;
							break;
						default:
							++ rage2x_cmd.etat[ options.num - NOMBRE_OPTIONS - 1 ] ;
							rage2x_cmd.etat[ options.num - NOMBRE_OPTIONS - 1 ] &= 1;
							options.need_save=ROUGE;
						break;
					}
				}else if (event.jbutton.button==GP2X_BUTTON_A || event.jbutton.button==GP2X_BUTTON_LEFT){
					switch (options.num)
					{
						case OPTION_NUM_GNGEO2X_SHOWFPS:
							--options.fps;
							options.fps&=1;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_SOUND:
							--options.sound;
							options.sound&=1;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_SAMPLERATE:
							--options.rate;
							if (options.rate==255) options.rate=2;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_CPU:
							--options.cpu;
#ifdef WIZ
							if (options.cpu==99) options.cpu=910;
#else
							if (options.cpu==99) options.cpu=310;
#endif
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_68K:
							--options.cpu68k;
							if (options.cpu68k==-51) options.cpu68k=50;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_Z80:
							--options.cpuz80;
							if (options.cpuz80==-51) options.cpuz80=50;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_RASTER:
							--options.raster;
							options.raster&=1;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_WIDE:
							--options.largeur;
							options.largeur&=1;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_SYSTEM:
							--options.system;
							if (options.system==255) options.system=2;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_COUNTRY:
							--options.pays;
							if (options.pays==255) options.pays=2;
							options.need_save=ROUGE;
							options.need_save_cf=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_TWEAK:
							--options.tweak;
							options.tweak &= 1;
							options.need_save=ROUGE;
						break;
						case OPTION_NUM_GNGEO2X_VSYNC:
							--options.vsync;
							options.vsync &= 1;
							options.need_save=ROUGE;
						break;
#ifdef WIZ
						case OPTION_NUM_GNGEO2X_DOUBLEBUF:
							--options.doublebuf;
							options.doublebuf &= 1;
							options.need_save=ROUGE;
						break;
						case OPTION_NUM_GNGEO2X_TEARINGFIX:
							--options.tearingfix;
							options.tearingfix &= 1;
							options.need_save=ROUGE;
						break;
#else
						case OPTION_NUM_GNGEO2X_TVOUT:
							--options.tvout;
							options.tvout &= 1;
							options.need_save=ROUGE;
						break;
						case OPTION_NUM_GNGEO2X_TVX:
							--options.tvoffset_x;
							if (options.tvoffset_x == -33) options.tvoffset_x = 31;
							if (flag_TV){
								carre_plein( ecran2 , 0 , 0 , 360 , 288 , Pnoir );
								SDL_UpdateRect( ecran2 , 0,0,0,0 );
							}
							options.need_save=ROUGE;
						break;
#endif
						case OPTION_NUM_GNGEO2X_TVY:
#ifndef WIZ
							--options.tvoffset_y;
							if (options.tvoffset_y == -33) options.tvoffset_y = 31;
							if (flag_TV){
								carre_plein( ecran2 , 0 , 0 , 360 , 288 , Pnoir );
								SDL_UpdateRect( ecran2 , 0,0,0,0 );
							}
							options.need_save=ROUGE;
#endif
						break;
						case OPTION_NUM_GNGEO2X_DUMPSPR:
							--options.dumpsprite;
							options.dumpsprite &= 1;
							options.need_save=ROUGE;
						break;
						case OPTION_NUM_RAGE2X_REPEATSPEED:
							--options.guispeed;
							if (options.guispeed==255) options.guispeed=2;
							options.need_save=ROUGE;
							break;
						case OPTION_NUM_GNGEO2X_FRONTEND:
							--options.reload;
							options.reload&=1;
							options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_LANGAGE:
							--options.langue;
							if (options.langue==255) options.langue=lng_num-1;
							options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_LIST:
							--options.listing;
							if (options.listing==255) options.listing=2;
							choix_jeu.y=36;
							choix_jeu.num=choix_jeu.offset_num=0;
							options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_RUN:
							--options.inv_run;
							options.inv_run&=1;
							options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_CLOCK:
							--options.rage2xclock;
#ifdef WIZ
							if ( options.rage2xclock == 65) options.rage2xclock = 533;
#else
							if ( options.rage2xclock == 65) options.rage2xclock = 133;
#endif
							options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_SCROLLBG:
							--options.scrollbg;
							options.scrollbg &= 1;
							options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_EDIT_PATH1:
							if ( edition_path(options.path[0] , 0 ) ) options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_EDIT_PATH2:
							if ( edition_path(options.path[1] , 1 ) ) options.need_save=ROUGE;
							break;
						case OPTION_NUM_RAGE2X_EDIT_EXIT:
							if ( edition_path(quit.temp , 2 ) ) options.need_save=ROUGE;
							break;
						case OPTION_NUM_SAVE:
							write_cfg();
							options.need_save=VERT;
							options.need_save_cf=VERT;
							break;
						case OPTION_NUM_SAVE_CF:
							write_cf(choix_jeu.num);
							load_cfg();
							options.need_save=VERT;
							options.need_save_cf=VERT;
							break;
						case OPTION_NUM_RETURN:
							if ( fenetre.ptr_mvt==0 ) fenetre.next=0;
							break;
						default:
							-- rage2x_cmd.etat[ options.num - NOMBRE_OPTIONS - 1 ] ;
							rage2x_cmd.etat[ options.num - NOMBRE_OPTIONS - 1 ] &= 1;
							options.need_save=ROUGE;
						break;
					}
				}else if (event.jbutton.button==GP2X_BUTTON_SELECT){
					//if ( fenetre.ptr_mvt==0 ) fenetre.next=0;
				}
			}
			++compteur;
		}else if (event.type==SDL_JOYBUTTONUP){
			//if (compteur) load_preview(choix_jeu.num);
			compteur=0;// reinitialisation joystick
		}
		
		//slide des fenetres
		if (fenetre.active!=fenetre.next){
			fenetre_x1-=mvt_fenetre[fenetre.ptr_mvt];
			fenetre_x2+=mvt_fenetre[fenetre.ptr_mvt];
			fenetre.ptr_mvt+=fenetre.sens;
			if (fenetre.ptr_mvt==28){
				fenetre.ptr_mvt=27;
				fenetre.sens=-1;
				fenetre.active=fenetre.next;
				OExit = 1;
			}
		}
		if (fenetre.sens==-1){
			fenetre_x1+=mvt_fenetre[fenetre.ptr_mvt];
			fenetre_x2-=mvt_fenetre[fenetre.ptr_mvt];
			fenetre.ptr_mvt+=fenetre.sens;
			if (fenetre.ptr_mvt==0){
				fenetre.sens=1;
			}
		}
		
	}	
}

int main(int argc, char *argv[])
{
	printf( "RAGE2X frontend for GNGEO2X\n");
	printf( "v"VERSION"\n");
	printf( "by JYCET\n");
	
	int Exit,ErrorQuit ;
	int Write = 0;
	
	SDL_Init(SDL_INIT_JOYSTICK | SDL_INIT_VIDEO | SDL_INIT_TIMER);

	if(!gp2x_dev) gp2x_dev = open("/dev/mem", O_RDWR);
#ifndef WIZ
	gp2x_memregs=(unsigned short *)mmap(0, 0x10000, PROT_READ|PROT_WRITE, MAP_SHARED, gp2x_dev, 0xc0000000);
	
	// TV OUT
	if((gp2x_memregs[0x2800>>1]&0x100)){
		if (gp2x_memregs[0x2818>>1]  == 287){ //PAL
			ecran2 = SDL_SetVideoMode(360, 288, 16, SDL_HWSURFACE);
//			offset_x = 7;
//			offset_y = 17;
		}else if (gp2x_memregs[0x2818>>1]  == 239){ //NTSC
			ecran2 = SDL_SetVideoMode(360, 240, 16, SDL_HWSURFACE);
//			offset_x = 7;
//			offset_y = 0;
		}
		ecran = SDL_CreateRGBSurface(SDL_HWSURFACE, 320, 240, 16, 0xf800, 0x07e0, 0x001f, 0x0000);
		flag_TV = 1;
	}else{
		//LCD
		ecran = SDL_SetVideoMode(320, 240, 16, SDL_HWSURFACE | SDL_DOUBLEBUF);
		flag_TV = 0;
	}
#else
	gp2x_memregs=(unsigned short *)mmap(0, 0x20000, PROT_READ|PROT_WRITE, MAP_SHARED, gp2x_dev, 0xc0000000);
	ecran = SDL_CreateRGBSurface(SDL_SWSURFACE, 320, 240, 16, 0xf800, 0x07e0, 0x001f, 0x0000);
	if(access("libSDL-1.2.so.0",F_OK)==0)
	{
		ecran2 = SDL_SetVideoMode(320, 240, 16, SDL_HWSURFACE|WIZ_TEARING|WIZ_MMUHACKOFF|WIZ_RAMTWEAKOFF);
	}
	else
	{
		pollux_set(gp2x_memregs, "lcd_timings=397,1,37,277,341,0,17,337;dpc_clkdiv0=9");
		ecran2 = SDL_SetVideoMode(320, 240, 16, SDL_HWSURFACE);
	}
#endif

	//ecran=SDL_SetVideoMode(320, 240, 16, SDL_HWSURFACE|SDL_DOUBLEBUF);
	SDL_ShowCursor (0); //desactive souris
	SDL_JoystickOpen(0);
	
	init_titre();
	
	unsigned int startime;
	unsigned int endtime,compteur;
	unsigned int synch60;
	unsigned int fps,fps_count;
	signed int i;
	Pgris = SDL_MapRGB(ecran->format, 192, 192, 192);
	Pblanc = SDL_MapRGB(ecran->format, 255, 255, 255);
	Pnoir = SDL_MapRGB(ecran->format, 0, 0, 0);
	
	fps=fps_count=0;
	startime=SDL_GetTicks();
	
	choix_jeu.y=options.y=POSY_LIST-1;
	choix_jeu.num=choix_jeu.offset_num=0;
	
	//options.y=123;
	options.num=0;
	options.nb=0;
	
	compteur=0;//pour deplacement joystick
	scroll_bg=0;
	demi_scroll=0;
	
	fenetre.active=fenetre.next=0;
	fenetre.sens=1;
	fenetre.ptr_mvt=0;
	
	//precalcul font7 x coordonne
	for (i=0;i<32;++i) font7x[i]=0;
	for (i=32;i<123;++i) font7x[i]=(i-32)*7;
	for (i=123;i<255;++i) font7x[i]=0;
	font7x[95]=0; // mise "_" en " "
	
	//precalucul table FPS
	for(i=1;i<255;++i)
		precalc_fps[i]=1000/i;
		
	load_cfg();
	
	options.need_save=VERT;
	options.need_save_cf=VERT;
	
	load_lng();
	load_dat();
	
	// lecture des commands externes
	rage2x_cmd.nb = 0 ;
	if ((fp = fopen("rage2x.cmd", "r")) != NULL){
		while(fgets(ligne,sizeof(ligne),fp) != NULL){
			if ( rage2x_cmd.nb < NB_MAX_EXT_ARG){
				sscanf(ligne, "%s", &arg1);
				//lit la ligne de commande
				rage2x_cmd.ligne[rage2x_cmd.nb] = (char*) malloc( strlen(arg1) * sizeof(char)+1);
				strcpy( rage2x_cmd.ligne[rage2x_cmd.nb] , arg1);
				//active par defaut la ligne de commande
				//rage2x_cmd.etat[rage2x_cmd.nb] = 1;
				//ligne de commande > 0
				++ rage2x_cmd.nb ;
			}else printf("Trop de ligne dans rage2x.cmd\n");
		}fclose(fp);
		
		//initialisation des etats de commande
		for (i=0 ; i<rage2x_cmd.nb ; ++i){
			rage2x_cmd.etat[i] = ( (rage2x_cmd.save>>i) & 1) ;
		}		
	}
	
#ifdef WIZ
	{
		char setup[50];
		sprintf(setup,"cpuclk=%d",options.rage2xclock);
		pollux_set(gp2x_memregs,setup);
	}
#else
	Set920Clock(options.rage2xclock);
	if (options.tweak) set_RAM_Timings(6, 4, 1, 1, 1, 2, 2);
#endif

	error.gngeo=0;
	error.bios=0;
	char *rom = NULL;
	unsigned nochecking = 0;
	if ( argc>1 ){
		for ( i=1 ; i<argc ; ++i ){
			if (strcmp(argv[i],"error_gngeo")==0) error.gngeo=1;
			else if (strncmp(argv[i],"nochecking",4)==0) nochecking = 1;
			else if (strncmp(argv[i],"rom=",4)==0){
				rom = (char*) calloc( strlen(argv[i])-4+1, sizeof(char));
				strcpy(rom,argv[i]+4);
				printf("rom %s\n", rom);
			}else{
				printf( "RAGE2X v"VERSION"\n");
				printf("usage: %s [options]\n", argv[0]);
				printf( "options:\n"
					"rom=<zipname> : launch rage2x with a preselected rom\n"
					"nochecking    : dont check gngeo2x files\n");
			}
		}
	}
	
	#define NB_FICHIERS	9
	unsigned char liste_fichiers_etats[NB_FICHIERS];
	char *liste_fichiers[NB_FICHIERS]={
#ifndef WIZ
		"gngeo.",
		"gngeo940.bin",
		"mmuhack.o",
#else
		"gngeo_wiz",
		"gngeo_wiz",
		"warm_2.6.24.ko",
#endif
 		"./skin/back.bmp",
		"./skin/font.bmp",
		"./skin/font_x2.bmp",
		"./skin/pbar.bmp",
		"./skin/pbar_back.bmp",
		/* bios obligatoire a faire check dans gngeorc : biospath ./roms*/
		"./conf/gngeorc."
	};
	#define NB_BIOS	8
	char *path_bios = "/roms";
	unsigned char liste_bios_etats[NB_BIOS];
	char *liste_bios[NB_BIOS]={
		"sfix.sfx",
		"000-lo.lo",
/*systeme  |  country  |*/
/*uni-bios | *         |*/  "uni-bios.rom",
/*home     | *         |*/ "aes-bios.rom",
/*arcade   | japan     |*/ "vs-bios.rom",
/*arcade   | usa       |*/ "usa_2slt.bin",
/*arcade   | asia      |*/ "asia-s3.rom",
/*arcade   | europe (en fait espagne IIRC) |*/ "sp-s2.sp1"
		};
	if (nochecking == 0){
		//fichiers ou dossiers a tester
		
		//rage2x.lng
		//rage2x.dat
		//rage2x.cmd
		// ./preview/
		// ./conf/
		
		for ( i=0 ; i<NB_FICHIERS ; ++i){
			sprintf((char*)g_string, "%s", liste_fichiers[i]);
			FILE *fp = fopen ( g_string , "r");
			if (fp == NULL)
			{
				/* fichier inexistant */
				liste_fichiers_etats[i] = 0;
				error.gngeo=1;
			}else{
				/* fichier existant */
				liste_fichiers_etats[i] = 1;
				fclose(fp);
			}
		}
		
		if (liste_fichiers_etats[8] == 1){
			//lecture path bios dans gngeorc
			if ((fp = fopen("./conf/gngeorc.", "r")) != NULL){
				while(fgets(ligne,sizeof(ligne),fp) != NULL){
					sscanf(ligne, "%s %s", &arg1,&arg2);
					if (strcmp(arg1,"#")!=0){
						if (strcmp(arg1,"biospath")==0){
							path_bios = (char*) malloc( strlen(arg2) * sizeof(char)+1);
							strcpy(path_bios,arg2);
							break;
						}
					}
				}fclose(fp);
			}else{
				liste_fichiers_etats[8] = 0;
				error.gngeo=1;
				printf("error gngeorc reading\n");
			}
			
			for ( i=0 ; i<NB_BIOS ; ++i){
				sprintf((char*)g_string, "%s/%s", path_bios, liste_bios[i]);
				FILE *fp = fopen ( g_string , "r");
				if (fp == NULL)
				{
					/* fichier inexistant */
					liste_bios_etats[i] = 0;
				}else{
					/* fichier existant */
					liste_bios_etats[i] = 1;
					fclose(fp);
				}
			}
			if (liste_bios_etats[0]==0 || liste_bios_etats[1]==0 || (liste_bios_etats[2]+liste_bios_etats[3]+liste_bios_etats[4]+liste_bios_etats[5]+liste_bios_etats[6]+liste_bios_etats[7])==0 )
				error.bios=1;
		}
		
	}else printf("nochecking files & folders\n");

	if (error.lng || error.dat || error.gngeo || error.bios){
		Exit=1;
		temp=8;
		sprintf((char*)g_string, "RAGE2X v"VERSION);
		put_string( g_string, 0, temp, BLANC);
		temp+=10;
		if (error.gngeo){
			for ( i=0 ; i<NB_FICHIERS ; ++i)
				if ( liste_fichiers_etats[i] == 0){
					sprintf((char*)g_string, "%s file missing", liste_fichiers[i]);
					put_string(g_string,8,temp,ROUGE);
					temp+=10;
				}
		}
		if (error.bios){
			for ( i=0 ; i<NB_BIOS ; ++i)
				if ( liste_bios_etats[i] == 0){
					sprintf((char*)g_string, "%s/%s bios missing", path_bios, liste_bios[i]);
					put_string(g_string,8,temp,ROUGE);
					temp+=10;
				}
		}
		if (error.lng){
			put_string25("rage2x.lng file missing",8,temp,ROUGE);
			temp+=10;
		}
		if (error.dat) put_string25("rage2x.dat file missing",8,temp,ROUGE);
		temp+=10;
		put_string25("Press any button to quit",8,temp,BLANC);
			
		rafraichir_ecran();
		//SDL_UpdateRect(ecran, 0, 0, 0, 0);
		while (!SDL_PollEvent(&event));
	}else{
		// initialisation des listes de jeux
		for (i=0;i<nb_list[0];++i) list[i][0]=i;
		temp=0;
		for (i=0;i<nb_list[0];++i)
			if (etat_jeux[i]==1){
				list[temp][1]=i;
				++temp;
			}
		temp=0;
		for (i=0;i<nb_list[0];++i)
			if (etat_jeux[i]==0){
				list[temp][2]=i;
				++temp;
			}
		nb_list[2]=nb_list[0]-nb_list[1];
			
		if ( rom != NULL ){
			for ( i=0 ; i<nb_list[options.listing] ; ++i){
				if (strcmp( data.zip[list[i][options.listing]] , rom ) == 0 ){
					printf("rom numero %d\n", i);
					choix_jeu.num = i;
					if (nb_list[options.listing]<20){
						choix_jeu.y = choix_jeu.y + (10*choix_jeu.num);
					}else{
						if (choix_jeu.num<10 /*|| choix_jeu.offset_num==(nb_list[options.listing]-LISTING)*/){
							choix_jeu.y = choix_jeu.y + (10*choix_jeu.num);
						}else if (choix_jeu.num > (nb_list[options.listing]-11) ){
							choix_jeu.offset_num = nb_list[options.listing]-19;
							choix_jeu.y = choix_jeu.y + (10*(choix_jeu.num-choix_jeu.offset_num));
						}else{
							choix_jeu.offset_num = choix_jeu.num - 10;
							choix_jeu.y = choix_jeu.y + (10*10);
						}
					}
				}
			}
		}
	
		load_preview(choix_jeu.num);
	
		fenetre_x1=4;
		fenetre_x2=168;
		
		Exit=0;
	}
	reset_frame_skip();	
	while (!Exit)
	{
		
		commun_gfx();
		
			
		//Listing jeux
		if (fenetre.active==0){
			ligneH(ecran,fenetre_x1-1,34,157, Pblanc);
			ligneH(ecran,fenetre_x1-1,227,157, Pblanc);
			ligneV(ecran,fenetre_x1-2,35,192, Pblanc);
			ligneV(ecran,fenetre_x1+156,35,192, Pblanc);

			if (nb_list[options.listing]) drawSprite(selecteur, ecran, 0, 0, fenetre_x1-1, choix_jeu.y, 157, 10);

			if (options.listing==0){
				for (i=choix_jeu.offset_num;i<(choix_jeu.offset_num+LISTING);++i){
					if (etat_jeux[i]==0)
						put_string25(data.name[i],fenetre_x1,pos_y,ROUGE);
					else 
						put_string25(data.name[i],fenetre_x1,pos_y,VERT);
					pos_y+=10;
				}
			}else{
				if (nb_list[options.listing]>LISTING){
					for (i=choix_jeu.offset_num;i<(choix_jeu.offset_num+LISTING);++i){
						put_string25(data.name[list[i][options.listing]],fenetre_x1,pos_y,options.listing<<3);
						pos_y+=10;
					}
				}else{
					for (i=0;i<nb_list[options.listing];++i){
						put_string25(data.name[list[i][options.listing]],fenetre_x1,pos_y,options.listing<<3);
						pos_y+=10;
					}
				}
			}
			
			ligneH(ecran,fenetre_x2-3,121,152, Pblanc);
			ligneH(ecran,fenetre_x2-3,200,152, Pblanc);
			ligneV(ecran,fenetre_x2-4,122,78, Pblanc);
			ligneV(ecran,fenetre_x2+149,122,78, Pblanc);
			//info jeu
			put_string25(txt[TXT_GAME_INFORMATION][options.langue],fenetre_x2,124,BLANC);
			sprintf((char*)g_string, "%s",data.manufacturer[list[choix_jeu.num][options.listing]]);
			put_string25(g_string,fenetre_x2,136,BLANC);
			sprintf((char*)g_string, "%d",data.year[list[choix_jeu.num][options.listing]]);
			put_string25(g_string,fenetre_x2,145,BLANC);
			sprintf((char*)g_string, "%d Mbits",data.size[list[choix_jeu.num][options.listing]]);
			put_string25(g_string,fenetre_x2,154,BLANC);
			sprintf((char*)g_string, "%s",data.type[list[choix_jeu.num][options.listing]]);
			put_string25(g_string,fenetre_x2,163,BLANC);
			sprintf((char*)g_string, "%s.zip",data.zip[list[choix_jeu.num][options.listing]]);
			put_string25(g_string,fenetre_x2,172,BLANC);
			sprintf((char*)g_string, "%s",data.status[list[choix_jeu.num][options.listing]]);
			put_string25(g_string,fenetre_x2,181,BLANC);
			if (flag_cf_file) sprintf((char*)g_string, "%s.cf YES",data.zip[list[choix_jeu.num][options.listing]]);
			else sprintf((char*)g_string, "%s.cf NO",data.zip[list[choix_jeu.num][options.listing]]);
			put_string25(g_string,fenetre_x2,190,BLANC);
			
			ligneH(ecran,fenetre_x2-3,205,152, Pblanc);
			ligneH(ecran,fenetre_x2-3,227,152, Pblanc);
			ligneV(ecran,fenetre_x2-4,206,21, Pblanc);
			ligneV(ecran,fenetre_x2+149,206,21, Pblanc);
			
			sprintf((char*)g_string, "%d %s",nb_list[0],txt[TXT_GAMES_IN_DATABASE][options.langue]);
			put_string25(g_string,fenetre_x2,208,BLANC);
			sprintf((char*)g_string,"%d %s",nb_list[1],txt[TXT_GAMES_AVAILABLE][options.langue]);
			put_string25(g_string,fenetre_x2,217,BLANC);

			//sprintf((char*)g_string,"%d %d %d", choix_jeu.offset_num , choix_jeu.num , choix_jeu.y );
			//put_string25( g_string , 0 , 0 , BLANC );


		pos_y=POSY_LIST;
		} else if (fenetre.active==2){
			ligneH(ecran,fenetre_x1-1,34,157, Pblanc);
			ligneH(ecran,fenetre_x1-1,77,157, Pblanc);
			ligneV(ecran,fenetre_x1-2,35,42, Pblanc);
			ligneV(ecran,fenetre_x1+156,35,42, Pblanc);
			
			drawSprite(selecteur, ecran, 0, 0,fenetre_x1-1, selecteur_y2, 157, 10);
			
			if (options.inv_run){
				sprintf((char*)g_string, "%s %s.cf",txt[TXT_RUN_WITH][options.langue],data.zip[list[choix_jeu.num][options.listing]]);
				put_string25(g_string,fenetre_x1,37,BLANC);
				sprintf((char*)g_string, "%s %s.cf",txt[TXT_RUN_WITHOUT][options.langue],data.zip[list[choix_jeu.num][options.listing]]);
				put_string25(g_string,fenetre_x1,47,BLANC);
			}else{
				sprintf((char*)g_string, "%s %s.cf",txt[TXT_RUN_WITHOUT][options.langue],data.zip[list[choix_jeu.num][options.listing]]);
				put_string25(g_string,fenetre_x1,37,BLANC);
				sprintf((char*)g_string, "%s %s.cf",txt[TXT_RUN_WITH][options.langue],data.zip[list[choix_jeu.num][options.listing]]);
				put_string25(g_string,fenetre_x1,47,BLANC);
			}
			put_string25(txt[TXT_RETURN_TO_GAME_LIST][options.langue],fenetre_x1,57,BLANC);
			put_string25(txt[TXT_EXIT_RAGE2X][options.langue],fenetre_x1,67,BLANC);

			if (selecteur_choix2==0){
				if (options.inv_run==0){
					ligneH(ecran,fenetre_x1-1,121,157, Pblanc);
					ligneH(ecran,fenetre_x1-1,227,157, Pblanc);
					ligneV(ecran,fenetre_x1-2,122,105, Pblanc);
					ligneV(ecran,fenetre_x1+156,122,105, Pblanc);
				}else{
					ligneH(ecran,fenetre_x2-3,121,152, Pblanc);
					ligneH(ecran,fenetre_x2-3,227,152, Pblanc);
					ligneV(ecran,fenetre_x2-4,122,105, Pblanc);
					ligneV(ecran,fenetre_x2+149,122,105, Pblanc);
				}					
			}else if (selecteur_choix2==1){
				if (options.inv_run==1){
					ligneH(ecran,fenetre_x1-1,121,157, Pblanc);
					ligneH(ecran,fenetre_x1-1,227,157, Pblanc);
					ligneV(ecran,fenetre_x1-2,122,105, Pblanc);
					ligneV(ecran,fenetre_x1+156,122,105, Pblanc);
				}else{
					ligneH(ecran,fenetre_x2-3,121,152, Pblanc);
					ligneH(ecran,fenetre_x2-3,227,152, Pblanc);
					ligneV(ecran,fenetre_x2-4,122,105, Pblanc);
					ligneV(ecran,fenetre_x2+149,122,105, Pblanc);
				}					
			}

			//config generale
			put_string25("Global setting",fenetre_x1,124,VERT);
			sprintf((char*)g_string, "cpu_speed %dMHz",options.cpu);
			put_string25(g_string,fenetre_x1,136,BLANC);
			sprintf((char*)g_string, "68kclock %d%c",options.cpu68k,37);
			put_string25(g_string,fenetre_x1,145,BLANC);
			sprintf((char*)g_string, "z80clock %d%c",options.cpuz80,37);
			put_string25(g_string,fenetre_x1,154,BLANC);
			if (options.sound) put_string25("sound true",fenetre_x1,163,BLANC);
			else put_string25("sound false",fenetre_x1,163,BLANC);
			if (options.rate==0) put_string25("samplerate 11025Hz",fenetre_x1,172,BLANC);		// modifi pour le 0.9beta
			else if (options.rate==1) put_string25("samplerate 22050Hz",fenetre_x1,172,BLANC);	// modifi pour le 0.9beta
			else put_string25("samplerate 44100Hz",fenetre_x1,172,BLANC);					// ajout pour le 0.9beta
			if (options.fps) put_string25("showfps true",fenetre_x1,181,BLANC);
			else put_string25("showfps false",fenetre_x1,181,BLANC);
			if (options.raster) put_string25("raster true",fenetre_x1,190,BLANC);				
			else put_string25("raster false",fenetre_x1,190,BLANC);				
			if (options.system==0) put_string25("system console",fenetre_x1,199,BLANC);
			else if (options.system==1) put_string25("system arcade",fenetre_x1,199,BLANC);
			else put_string25("system unibios",fenetre_x1,199,BLANC);
			if (options.pays==0) put_string25("country japan",fenetre_x1,208,BLANC);
			else if (options.pays==1) put_string25("country usa",fenetre_x1,208,BLANC);
			else put_string25("country europe",fenetre_x1,208,BLANC);
			if (options.largeur) put_string25("screen320 true",fenetre_x1,217,BLANC);
			else put_string25("screen320 false",fenetre_x1,217,BLANC);

			//config *.cf
			sprintf((char*)g_string, "%s.cf setting",data.zip[list[choix_jeu.num][options.listing]]);
			if (flag_cf_file) put_string25(g_string,fenetre_x2,124,VERT);
			else put_string25(g_string,fenetre_x2,124,ROUGE);
			
			sprintf((char*)g_string, "cpu_speed %sMHz",conf.cpu_speed);
			put_string25(g_string,fenetre_x2,136,BLANC);
			sprintf((char*)g_string, "68kclock %s%c",conf.clock68k,37);
			put_string25(g_string,fenetre_x2,145,BLANC);
			sprintf((char*)g_string, "z80clock %s%c",conf.z80clock,37);
			put_string25(g_string,fenetre_x2,154,BLANC);
			sprintf((char*)g_string, "sound %s",conf.sound);
			put_string25(g_string,fenetre_x2,163,BLANC);
			sprintf((char*)g_string, "samplerate %sHz",conf.samplerate);
			put_string25(g_string,fenetre_x2,172,BLANC);				
			sprintf((char*)g_string, "showfps %s",conf.showfps);
			put_string25(g_string,fenetre_x2,181,BLANC);
			sprintf((char*)g_string, "raster %s",conf.raster);
			put_string25(g_string,fenetre_x2,190,BLANC);				
			sprintf((char*)g_string, "system %s",conf.system);
			put_string25(g_string,fenetre_x2,199,BLANC);
			sprintf((char*)g_string, "country %s",conf.country);
			put_string25(g_string,fenetre_x2,208,BLANC);
			sprintf((char*)g_string, "screen320 %s",conf.screen320);
			put_string25(g_string,fenetre_x2,217,BLANC);

		}
		
		rafraichir_ecran();

		SDL_PollEvent(&event);
		if (event.type==SDL_JOYBUTTONDOWN){
			if (compteur==0 || (compteur>30 && ((compteur&joy_speed[options.guispeed])==0))){
				if (event.jbutton.button==GP2X_BUTTON_UP){
					if (fenetre.active==0){
						if (choix_jeu.num>(nb_list[options.listing]-10) || choix_jeu.offset_num==0){
							if (choix_jeu.num>0){
								choix_jeu.y-=10;
								--choix_jeu.num;
								//if (compteur==0) load_preview(choix_jeu.num);
							}
						}else{
							--choix_jeu.offset_num;
							--choix_jeu.num;
							//if (compteur==0) load_preview(choix_jeu.num);
						}
					}else if (fenetre.active==2){
						if(selecteur_choix2>0){
							--selecteur_choix2;
							selecteur_y2-=10;
						}
					}
				}else if (event.jbutton.button==GP2X_BUTTON_DOWN){
					if (fenetre.active==0){
						if (nb_list[options.listing]<20){
								if (choix_jeu.num<(nb_list[options.listing]-1)){
									choix_jeu.y+=10;
									++choix_jeu.num;
									//if (compteur==0) load_preview(choix_jeu.num);
								}
						}else{
							if (choix_jeu.num<10 || choix_jeu.offset_num==(nb_list[options.listing]-LISTING)){
								if (choix_jeu.num<(nb_list[options.listing]-1)){
									choix_jeu.y+=10;
									++choix_jeu.num;
									//if (compteur==0) load_preview(choix_jeu.num);
								}
							}else{
								++choix_jeu.offset_num;
								++choix_jeu.num;
								//if (compteur==0) load_preview(choix_jeu.num);
							}
						}
					}else if (fenetre.active==2){
						if(selecteur_choix2<3){
							++selecteur_choix2;
							selecteur_y2+=10;
						}
					}
				}else if (event.jbutton.button==GP2X_BUTTON_R){ // go top
					if (fenetre.active==0){
						choix_jeu.y=36;
						choix_jeu.num=choix_jeu.offset_num=0;
					}
				}else if (event.jbutton.button==GP2X_BUTTON_L){ // go bottom
					if (fenetre.active==0){
						if (nb_list[options.listing]>LISTING){
							choix_jeu.y=216;
							choix_jeu.num=nb_list[options.listing]-1;
							choix_jeu.offset_num=nb_list[options.listing]-LISTING;
						}
					}
				}else if (event.jbutton.button==GP2X_BUTTON_A || event.jbutton.button==GP2X_BUTTON_B ){
					if (fenetre.active==0  && fenetre.ptr_mvt==0){
						fenetre.next=2;
						selecteur_y2=POSY_LIST-1;
						selecteur_choix2=0;
					}else if (fenetre.active==2){
						if ((selecteur_choix2==0 && options.inv_run==0) || (selecteur_choix2==1 && options.inv_run==1)){
							if (etat_jeux[list[choix_jeu.num][options.listing]]==0){
								put_string25("ROM NOT FOUND",168,124,BLANC);
							}else{
								// executer l'emu
								ar=0;
								argument[ ar ] = "gngeo";
#ifdef WIZ
								argument[ ar ] = "gngeo_wiz";
#endif
								++ar;
								if (options.fps){
									argument[ ar ] = "--showfps";
									++ar;
								}else{
									argument[ ar ] = "--no-showfps";
									++ar;
								}
								if (options.sound){
									argument[ ar ] = "--sound";
									++ar;
									if (options.rate==0){
										argument[ ar ] = "--samplerate=11025";
										++ar;
									}else if (options.rate==1){
										argument[ ar ] = "--samplerate=22050";
										++ar;
									}else if (options.rate==2){
										argument[ ar ] = "--samplerate=44100";
										++ar;
									}
								}else{
									argument[ ar ] = "--no-sound";
									++ar;
								}
#ifdef WIZ
								if (options.cpu != 533){
									sprintf((char*)g_string, "--cpu_speed=%d",options.cpu);
									argument[ ar ] = (char*) malloc( strlen(g_string) * sizeof(char)+1);
									strcpy(argument[ ar ],g_string);
									++ar;
								}else pollux_set(gp2x_memregs,"cpuclk=533");
#else
								if (options.cpu != 200){
									sprintf((char*)g_string, "--cpu_speed=%d",options.cpu);
									argument[ ar ] = (char*) malloc( strlen(g_string) * sizeof(char)+1);
									strcpy(argument[ ar ],g_string);
									++ar;
								}else Set920Clock(200);
#endif
								//if (options.cpu68k){
									sprintf((char*)g_string, "--68kclock=%d",options.cpu68k);
									argument[ ar ] = (char*) malloc( strlen(g_string) * sizeof(char)+1);
									strcpy(argument[ ar ],g_string);
									++ar;
								//}
								//if (options.cpuz80){
									sprintf((char*)g_string, "--z80clock=%d",options.cpuz80);
									argument[ ar ] = (char*) malloc( strlen(g_string) * sizeof(char)+1);
									strcpy(argument[ ar ],g_string);
									++ar;
								//}
								if (options.reload){
									argument[ ar ] = "--frontend=rage2x.gpe";
									++ar;
								}
								if (options.raster){
									argument[ ar ] = "--raster";
									++ar;
								}else{
									argument[ ar ] = "--no-raster";
									++ar;
								}
								if (options.largeur){
									argument[ ar ] = "--screen320";
									++ar;
								}else{
									argument[ ar ] = "--no-screen320";
									++ar;
								}
								if (options.system==2){
									argument[ ar ] = "--system=unibios";
									++ar;
								}else if (options.system==1){
									argument[ ar ] = "--system=arcade";
									++ar;
								}else {
									argument[ ar ] = "--system=console";
									++ar;
								}									
								if (options.pays==0){
									argument[ ar ] = "--country=japan";
									++ar;
								}else if (options.pays==1){
									argument[ ar ] = "--country=usa";
									++ar;
								}else{
									argument[ ar ] = "--country=europe";
									++ar;
								}
								/****************************nouvelles options************************/
								if (options.tweak){
#ifdef WIZ
									pollux_set(gp2x_memregs,"ram_timings=2,9,4,1,1,1,1");
#else
									argument[ ar ] = "--ramhack";
									++ar;
								}else{
									argument[ ar ] = "--no-ramhack";
									++ar;
#endif
								}
								if (options.vsync){
									argument[ ar ] = "--vsync";
									++ar;
								}else{
									argument[ ar ] = "--no-vsync";
									++ar;
								}
#ifdef WIZ
								if (options.doublebuf){
									argument[ ar ] = "--doublebuf";
									++ar;
								}else{
									argument[ ar ] = "--no-doublebuf";
									++ar;
								}
								if (options.tearingfix){
									argument[ ar ] = "--tearingfix";
									++ar;
								}else{
									argument[ ar ] = "--no-tearingfix";
									++ar;
								}
#else
								if (options.tvout){
									argument[ ar ] = "--tvout";
									++ar;
								}else{
									argument[ ar ] = "--no-tvout";
									++ar;
								}
								if (flag_TV){
									if (options.tvoffset_x || options.tvoffset_y){
										sprintf((char*)g_string, "--tv_offset=%d,%d",options.tvoffset_x,options.tvoffset_y);
										argument[ ar ] = (char*) malloc( strlen(g_string) * sizeof(char)+1);
										strcpy(argument[ ar ],g_string);
										++ar;
									}
								}
#endif
								if (options.dumpsprite){
									argument[ ar ] = "--dumpsprite";
									++ar;
								}

								/*******************************************************************/
								if (rage2x_cmd.nb)
									for (i=0 ; i<rage2x_cmd.nb ; ++i)
										if (rage2x_cmd.etat[i]){
											argument[ ar ] = (char*) malloc( strlen(rage2x_cmd.ligne[i]) * sizeof(char)+1);
											strcpy(argument[ ar ] , rage2x_cmd.ligne[i]);
											++ar;
										}
								/*******************************************************************/

								sprintf((char*)g_string, "%s%s.zip",options.path[data.path[list[choix_jeu.num][options.listing]]],data.zip[list[choix_jeu.num][options.listing]]);
								argument[ ar ] = (char*) malloc( strlen(g_string) * sizeof(char)+1);
								strcpy(argument[ ar ],g_string);
								++ar;
								argument[ ar ] = (char *)0;
								path = "gngeo";
#ifdef WIZ
								path = "gngeo_wiz";
#endif
								
								libere_memoire();
								SDL_JoystickClose(0);
								SDL_Quit();
								
								printf("Ligne de commande:\n");
								for ( i=0 ; i<ar ; ++i )
									printf("%s ",argument[i]);
								printf("\n");
								
								execv(path, argument);
								printf("Echec de lancement de GNGEO\n");
								printf("Reboot RAGE2X\n");
								execl("rage2x.gpe","rage2x.gpe","error_gngeo",NULL);
							}
						}else if (( selecteur_choix2==1 && options.inv_run==0) || ( selecteur_choix2==0 && options.inv_run==1)){
							if (etat_jeux[list[choix_jeu.num][options.listing]]==0){
								put_string25("ROM NOT FOUND",168,124,BLANC);
							}else{
								// executer l'emu
#ifdef WIZ
								pollux_set(gp2x_memregs,"cpuclk=533");
#else
								Set920Clock(200);
#endif
								ar=0;
								argument[ ar ] = "gngeo";
#ifdef WIZ
								argument[ ar ] = "gngeo_wiz";
#endif
								++ar;
								if (options.reload){
									argument[ ar ] = "--frontend=rage2x.gpe";
									++ar;
								}
								sprintf((char*)g_string, "%s%s.zip",options.path[data.path[list[choix_jeu.num][options.listing]]],data.zip[list[choix_jeu.num][options.listing]]);
								argument[ ar ] = (char*) malloc( strlen(g_string) * sizeof(char)+1);
								strcpy(argument[ ar ],g_string);
								++ar;
								argument[ ar ] = (char *)0;
								path = "gngeo";
#ifdef WIZ
								path = "gngeo_wiz";
#endif
								
								libere_memoire();
								SDL_JoystickClose(0);
								SDL_Quit();

								execv(path, argument);
								printf("Echec de lancement de GNGEO\n");
								printf("Reboot RAGE2X\n");
								execl("rage2x.gpe","rage2x.gpe","error_gngeo",NULL);
							}
						}else if (selecteur_choix2==2  && fenetre.ptr_mvt==0){
							fenetre.next=0;
						}else if (selecteur_choix2==3){
							Exit = 1;
							//if (credit()) Exit = 1;
						}
					}
					
				}else if (event.jbutton.button==GP2X_BUTTON_START){
					if (credit()) Exit = 1;
				}else if (event.jbutton.button==GP2X_BUTTON_SELECT){
					if (fenetre.active==0 && fenetre.ptr_mvt==0) fenetre.next=1;
					else if (fenetre.active==1 && fenetre.ptr_mvt==0) fenetre.next=0;
				}
			}
			++compteur;
		}else if (event.type==SDL_JOYBUTTONUP){
			if (fenetre.active==0)
				if (compteur) load_preview(choix_jeu.num);
			compteur=0;// reinitialisation joystick
		}
		
		//slide des fenetres
		if (fenetre.active!=fenetre.next){
			fenetre_x1-=mvt_fenetre[fenetre.ptr_mvt];
			fenetre_x2+=mvt_fenetre[fenetre.ptr_mvt];
			fenetre.ptr_mvt+=fenetre.sens;
			if (fenetre.ptr_mvt==28){
				fenetre.ptr_mvt=27;
				fenetre.sens=-1;
				fenetre.active=fenetre.next;
				if (fenetre.active==1) sp_options();
			}
		}
		if (fenetre.sens==-1){
			fenetre_x1+=mvt_fenetre[fenetre.ptr_mvt];
			fenetre_x2-=mvt_fenetre[fenetre.ptr_mvt];
			fenetre.ptr_mvt+=fenetre.sens;
			if (fenetre.ptr_mvt==0){
				fenetre.sens=1;
			}
		}
	}

	libere_memoire();
	SDL_JoystickClose(0);
	SDL_Quit();
#ifdef WIZ
	pollux_set(gp2x_memregs,"cpuclk=533");
#else
	set_RAM_Timings(8, 16, 3, 8, 8, 8, 8);
#endif
	chdir( quit.path );
	execl( quit.prg , quit.prg , NULL );
	printf("Echec de retour vers:\n");
	printf("%s%s\n",quit.path,quit.prg);
#ifndef WIZ
	printf("Lancement menu par defaut\n");
	chdir("/usr/gp2x");
	execl("gp2xmenu","gp2xmenu",NULL);
#endif
	return 0;
}


/*EOF*/
