/*  RAGE2X for GP2X

    Copyright (C) 2006  JyCet

    Part Set920Clock copyright (C) 2005  Hermes/PS2Reality 
	Modified by Vimacs using Robster's Code and god_at_hell(LCD)
	
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// GNGEO2X Frontend
// JYCET 2K6
//
#include <fcntl.h>
#include <sys/mman.h>

#define GP2X_BUTTON_UP              (0)
#define GP2X_BUTTON_DOWN            (4)
#define GP2X_BUTTON_LEFT            (2)
#define GP2X_BUTTON_RIGHT           (6)
#define GP2X_BUTTON_UPLEFT          (1)
#define GP2X_BUTTON_UPRIGHT         (7)
#define GP2X_BUTTON_DOWNLEFT        (3)
#define GP2X_BUTTON_DOWNRIGHT       (5)
#define GP2X_BUTTON_CLICK           (18)
#define GP2X_BUTTON_A               (12)
#define GP2X_BUTTON_B               (13)
#define GP2X_BUTTON_X               (14)
#define GP2X_BUTTON_Y               (15)
#define GP2X_BUTTON_L               (10)
#define GP2X_BUTTON_R               (11)
#define GP2X_BUTTON_START           (8)
#define GP2X_BUTTON_SELECT          (9)
#define GP2X_BUTTON_VOLUP           (16)
#define GP2X_BUTTON_VOLDOWN         (17)

#define BLANC	0
#define VERT	8
#define ROUGE	16
#define BLEU	24

#define OUI	1
#define NON	0
#define N_ARG 30
#define NB_MAX_EXT_ARG 16

#define UK	0
#define FR	1

#define NB_MAX_JEUX	255
#define NB_MAX_LNG	50
#define NB_OPTIONS	17	//nb d'options - 1
#define POSY_LIST	37
#define LISTING	19

#define TICKS_PER_SEC       1000000UL

#define OPTION_NUM_GNGEO2X_SHOWFPS	0
#define OPTION_NUM_GNGEO2X_SOUND		1
#define OPTION_NUM_GNGEO2X_SAMPLERATE	2
#define OPTION_NUM_GNGEO2X_CPU		3
#define OPTION_NUM_GNGEO2X_68K		4
#define OPTION_NUM_GNGEO2X_Z80		5
#define OPTION_NUM_GNGEO2X_RASTER		6
#define OPTION_NUM_GNGEO2X_WIDE		7
#define OPTION_NUM_GNGEO2X_SYSTEM		8
#define OPTION_NUM_GNGEO2X_COUNTRY	9
#define OPTION_NUM_GNGEO2X_TWEAK		10
#define OPTION_NUM_GNGEO2X_VSYNC		11
#ifdef WIZ
#define OPTION_NUM_GNGEO2X_DOUBLEBUF	12
#define OPTION_NUM_GNGEO2X_TEARINGFIX	13
#else
#define OPTION_NUM_GNGEO2X_TVOUT		12
#define OPTION_NUM_GNGEO2X_TVX		13
#endif
#define OPTION_NUM_GNGEO2X_TVY		14
#define OPTION_NUM_GNGEO2X_DUMPSPR	15
#define OPTION_NUM_GNGEO2X_HOTKEY0	16
#define OPTION_NUM_GNGEO2X_HOTKEY1	17

#define OPTION_NUM_RAGE2X_REPEATSPEED	16
#define OPTION_NUM_GNGEO2X_FRONTEND	17

#define OPTION_NUM_RAGE2X_LANGAGE		18
#define OPTION_NUM_RAGE2X_LIST		19	
#define OPTION_NUM_RAGE2X_RUN			20
#define OPTION_NUM_RAGE2X_CLOCK		21
#define OPTION_NUM_RAGE2X_SCROLLBG		22
#define OPTION_NUM_RAGE2X_EDIT_PATH1	23
#define OPTION_NUM_RAGE2X_EDIT_PATH2	24
#define OPTION_NUM_RAGE2X_EDIT_EXIT	25

#define OPTION_NUM_SAVE				26
#define OPTION_NUM_SAVE_CF			27
#define OPTION_NUM_RETURN			28

#define NOMBRE_OPTIONS				OPTION_NUM_RETURN

#define TXT_GAME_INFORMATION		0
#define TXT_GAMES_IN_DATABASE		1
#define TXT_GAMES_AVAILABLE		2
#define TXT_SHOW_FRAMERATE		3
#define TXT_ACTIVATE_SOUND		4
#define TXT_CPU_SPEED			5
#define TXT_GUI_SPEED			6
#define TXT_AUTO_RELOAD_GUI		7
#define TXT_ACTIVATE_RASTER		8
#define TXT_INVERT_RUN_CHOICE		9
#define TXT_RESOLUTION_320x224		10
#define TXT_SYSTEM_CONSOLE		11
#define TXT_SYSTEM_ARCADE		12
#define TXT_SYSTEM_UNIBIOS		13
#define TXT_COUNTRY_JAPAN		14
#define TXT_COUNTRY_USA			15
#define TXT_COUNTRY_EUROPE		16
#define TXT_ENGLISH_LANGUAGE		17
#define TXT_SEE_COMPLETE_LIST		18
#define TXT_SEE_LIST_AVAILABLE		19
#define TXT_SEE_MISSING_LIST		20
#define TXT_SAVE_ALL_SETTING		21
#define TXT_GENERATE			22
#define TXT_68K_CLOCK			23
#define TXT_Z80_CLOCK			24
#define TXT_RUN_WITHOUT			25
#define TXT_RUN_WITH			26
#define TXT_RETURN_TO_GAME_LIST	27
#define TXT_EXIT_RAGE2X			28
#define TXT_RAGE2X_CLOCK			29
#define TXT_CRAIGX_RAM_TIMING		30
#define TXT_VSYNC				31
#define TXT_TVOUT				32
#define TXT_TV_SCREEN_OFFSET_X	33
#define TXT_TV_SCREEN_OFFSET_Y	34
#define TXT_DUMP_SPRITE			35
#define TXT_WALLPAPER_SCROLLING	36
#define TXT_EDIT_ROMS_PATH_1		37
#define TXT_EDIT_ROMS_PATH_2		38
#define TXT_EDIT_EXIT_PROGRAM		39
#define TXT_Actual_path			40
#define TXT_New_path				41
#define TXT_CANCEL				42
#define TXT_APPLY				43
#define TXT_RESTORE_DEFAULT_PATH	44
#define TXT_DOUBLEBUFFERING		45
#define TXT_TEARINGFIX			46

SDL_Event event;

SDL_Surface *ecran;
SDL_Surface *ecran2;
SDL_Surface *bg;
SDL_Surface *font;
SDL_Surface *preview0;
SDL_Surface *preview;
SDL_Surface *selecteur;
SDL_Surface *titre;
SDL_Surface *indicateur;
SDL_Surface *Tmp;

SDL_RWops *rw;

FILE *fp;

char g_string[255];
char arg1[128];
char arg2[128];
char arg3[128];
char arg4[128];
char arg5[128];
char arg6[128];
char arg7[128];
char ar;
int	argd;
unsigned int	argd2;
char ligne[256];

char * path; 
char * argument[N_ARG];

unsigned int font7x[255];
unsigned char precalc_fps[255];

unsigned char etat_jeux[NB_MAX_JEUX];
unsigned char temp,flag_cf_file,lng_num;
signed int /*offset_fenetre_x,*/fenetre_x1,fenetre_x2/*,fenetre_x_tmp*/;
unsigned char selecteur_y2,selecteur_choix2;
unsigned char pos_y;
Uint32 Pblanc;
Uint32 Pgris;
Uint32 Pnoir;

long ptrFP,ptrFP2;
// colonne 0 = tous
// colonne 1 = dispo
// colonne 2 = manquant
unsigned char list[NB_MAX_JEUX][3];
unsigned char nb_list[3];
signed int x,y;
unsigned char scroll_bg, demi_scroll;

//fix TV
unsigned long   gp2x_dev;
unsigned short *gp2x_memregs;

unsigned char flag_TV;
unsigned char offset_x , offset_y ;
//double lim_time;
//int target_frametime = 16666;
// ti pour temps initial
// tf pour temps final
//struct timeval ti,tf;

struct data
{
	char *name[NB_MAX_JEUX];
	char *zip[NB_MAX_JEUX];
	char *manufacturer[NB_MAX_JEUX];
	unsigned int year[NB_MAX_JEUX];
	unsigned int size[NB_MAX_JEUX];
	char *type[NB_MAX_JEUX];
	char *status[NB_MAX_JEUX];
	unsigned char path[NB_MAX_JEUX];
}data;

struct conf
{
	char *cpu_speed;
	char *clock68k;
	char *z80clock;
	char *sound;
	char *samplerate;
	char *showfps;
	char *raster;
	char *system;
	char *country;
	char *screen320;
}conf;

char *txt[50][NB_MAX_LNG];

struct choix_jeu
{
	unsigned char y;
	unsigned char num;
	unsigned char offset_num;
}choix_jeu;

struct options
{
	unsigned char y;
	unsigned char need_save;
	unsigned char need_save_cf;
	unsigned char offset_num;
	unsigned char num;
	char *path[2];
	unsigned char fps;
	unsigned char sound;
	unsigned char rate;
	unsigned int cpu;
	signed char cpu68k;
	signed char cpuz80;
	unsigned char reload;
	unsigned char raster;
	unsigned char system;
	unsigned char pays;
	unsigned char largeur;
	unsigned char nb;
	unsigned char listing;
	unsigned char guispeed;
	unsigned char langue;
	unsigned char inv_run;
	unsigned int rage2xclock;
	unsigned char scrollbg;

	unsigned char tweak;
	unsigned char vsync;
#ifdef WIZ
	unsigned char doublebuf;
	unsigned char tearingfix;
#else
	unsigned char tvout;
	signed char tvoffset_x;
	signed char tvoffset_y;
#endif
	unsigned char dumpsprite;
	char *hotkey0;
	char *hotkey1;
}options;

struct rage2x_cmd
{
	unsigned char nb;
	char *ligne[NB_MAX_EXT_ARG];
	unsigned char etat[NB_MAX_EXT_ARG];
	unsigned int save;
}rage2x_cmd;

struct fenetre
{
	signed char sens;
	unsigned char ptr_mvt;
	unsigned char next;
	unsigned char active;
}fenetre;

struct error
{
	unsigned char lng;
	unsigned char dat;
	unsigned char gngeo;
	unsigned char bios;
}error;

struct quit
{
	char *prg;
	char *path;
	char *temp;
}quit;

//char *VERSION = "1.0.1 beta10";
#define VERSION	"1.1"

char *hotkey[10][2]={
	{"A+B","1,2"},
	{"A+C","1,4"},
	{"A+D","1,8"},
	{"B+C","2,4"},
	{"B+D","2,8"},
	{"C+D","4,8"},
	{"A+B+C","1,2,4"},
	{"A+B+D","1,2,8"},
	{"B+C+D","2,4,8"},
	{"A+B+C+D","1,2,4,8"}
	};
	
void put_string(char *string, unsigned int pos_x, unsigned int pos_y, unsigned char couleur);
void put_string25(char *string, unsigned int pos_x, unsigned int pos_y, unsigned char couleur);

unsigned char joy_speed[4]={0,1,3,7};

void rafraichir_ecran(void);

void ligneH(SDL_Surface* screenSurface, int x, int y, int w, Uint32 coul)
{
  SDL_Rect r;

  r.x = x;
  r.y = y;
  r.w = w;
  r.h = 1;

  SDL_FillRect(screenSurface, &r, coul);
}

void ligneV(SDL_Surface* screenSurface, int x, int y, int h, Uint32 coul)
{
  SDL_Rect r;

  r.x = x;
  r.y = y;
  r.w = 1;
  r.h = h;

  SDL_FillRect(screenSurface, &r, coul);
}

void drawSprite(SDL_Surface* imageSurface, SDL_Surface* screenSurface, int srcX, int srcY, int dstX, int dstY, int width, int height)
{
	SDL_Rect srcRect;
	srcRect.x = srcX;
	srcRect.y = srcY;
	srcRect.w = width;
	srcRect.h = height;

	SDL_Rect dstRect;
	dstRect.x = dstX;
	dstRect.y = dstY;
	dstRect.w = width;
	dstRect.h = height;

	SDL_BlitSurface(imageSurface, &srcRect, screenSurface, &dstRect);
}

unsigned char mvt_fenetre[28]={
	0,1,2,2,3,3,4,4,4,
	5,5,5,5,6,6,6,6,
	6,8,8,8,8,8,10,10,10,10,10
};

void carre_plein(SDL_Surface* screenSurface, int x, int y, int w, int h,Uint32 coul)
{
  SDL_Rect r;

  r.x = x;
  r.y = y;
  r.w = w;
  r.h = h;

  SDL_FillRect(screenSurface, &r, coul);
}
